/***************************************************************************
                          sqlguidoc.h  -  description
                             -------------------
    begin                : Sat Apr 14 18:28:06 CEST 2001
    copyright            : (C) 2001 by mb
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SQLGUIDOC_H
#define SQLGUIDOC_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for QT
#include <qobject.h>
#include <qstring.h>
#include <qlist.h>

// include files for KDE
#include <kurl.h>

#include <string.h>
#include <stdlib.h>

#include <mysql.h>

// forward declaration of the SqlGui classes
class SqlGuiView;
//class SqlGuiPart;
class KLocale;

#include "db_components.h"


/**	SqlGuiDoc provides a document object for a document-view model.
  *
  * The SqlGuiDoc class provides a document object that can be used in conjunction with the classes SqlGuiApp and SqlGuiView
  * to create a document-view model for standard KDE applications based on KApplication and KMainWindow. Thereby, the document object
  * is created by the SqlGuiApp instance and contains the document structure with the according methods for manipulation of the document
  * data by SqlGuiView objects. Also, SqlGuiDoc contains the methods for serialization of the document data from and to files.
  *
  * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team. 	
  * @version KDevelop version 1.2 code generation
  */
class SqlGuiDoc : public QObject
{
  Q_OBJECT

//	friend class SqlGuiView;
//	friend class SqlGuiPart;

  public:
    SqlGuiDoc(QWidget *parent, const char *name=0);
    ~SqlGuiDoc();
    QString* resultDB();
    QString* resultTable();
    spalten_t* resultCols();
    void addView(SqlGuiView *view);
    void removeView(SqlGuiView *view);
    void setModified(bool _m=true){ modified=_m; };
    bool isModified(){ return modified; };
    bool saveModified();	
    void deleteContents();
    bool newDocument();
    void closeDocument();
    bool openDocument(const QString& url, const QString& uname, const QString& pwd);
    bool saveDocument(const KURL& url, const char *format=0);
    const KURL& URL() const;
    void setURL(const KURL& url);
    base_t * getDBs(){return DB;}
    row_t * getFirstRes(){return RESULT_Start;}
    row_t * getNextRes(){row_t* help=RESULT;RESULT=RESULT->next;if(!RESULT){RESULT=RESULT_Start;} return help;}
    QString * getLastTable();
    QString * getPrimaryKey();
		QString getHost();
		QString getUser();
		QString getPass();
    unsigned short int getPort();

    bool gotoNextBase();
    bool gotoNextTable();
    bool gotoNextColumn();
    bool gotoNextRow();
    bool gotoNextField();
    base_t* getActualBase();
    table_t* getActualTable();
    spalten_t* getActualColumn();
    row_t* getActualRow();
    field_t* getActualField();
    QString getActualBaseName();
    QString getActualTableName();
    QString getActualTableType();
    QString getActualColumnName();
    void setView( SqlGuiView* v );
		bool isConnected();


  public slots:
    void slotUpdateAllViews(SqlGuiView *sender);
    void slotDoQuery(QString * Base, QString* Anfrage);
    void slotDbCreate( QString* );
    void slotDoLogin( QString, QString, QString);
    void slotDbDelete( QString* db );
    void slotReConnect();
    void slotTableDelete(QString* db, QString* tb);
    void slotTableCheck(QString* db, QString* tb);
    void slotTableOptimize(QString* db, QString* tb);
    void slotTableRepair(QString* db, QString* tb);
    void slotClearMemory();
		void slotServerStatus();
		void slotCountRows( QString* _db, QString* _tb);

  public:	
    static QList<SqlGuiView> *pViewList;	

 signals:
    void connectionChanged();
    void loginComplete();
    void loginError();
    void resultChanged();
    void tableChecked();
    void tableOptimized();
    void tableRepaired();
    void NewDbCreated();
    void NewTableCreated();
    void DbErased();
    void TableErased();
    void DbQueryError( QString* errmsg );
		void QueryDone();
    void queryEmpty();
		void lastActionChanged( QString* db, QString* tab, QString* prim);
		void serverStatus( QString status );

  private:
    bool modified;
    KURL doc_url;

	public:
    QString doc_host;
		unsigned short int doc_port;
    QString doc_uname;
    QString doc_pass;

    base_t * DB;				
    QString *QUERY;
    QString *STATUS;
    QString *lastDB;
    QString *lastTable;
    QString *primKey;

    int stat;         // MySQL-Error-Code

    int field_pos;    // Aktuelle Position in der altuellen Zeile
    int row_pos;      // Aktuelle Zeilen-Position
		
    row_t* RESULT_Start;    // Pointer auf das erste Zeilen-Element der letzten SQL-Anfrage
    row_t* RESULT;          // Pointer auf das aktuelle Zeilen-Element der letzten SQL-Anfrage

	protected:
    QString getDbFromSQL(QString * sql);
    QString getTableFromSQL(QString * sql);
    spalten_t * lastCols;   // Pointer auf eine List mit den Spalten-Namen der letzten SQL-Query
		QWidget *myParentWidget;
		KLocale* kl;

    private slots:
    void slotUpdate(MYSQL_RES * res);
    void clearResult();

 private:
    base_t*    cleardb( base_t ** db );
    table_t*   cleartb( table_t ** tb );
    spalten_t* clearsp( spalten_t ** sp );
    row_t*     clearrw( row_t ** rw );
    field_t*   clearfd( field_t ** fd );

    base_t*    basePosition;
    table_t*   tablePosition;
    spalten_t* columnPosition;
    row_t*     rowPosition;
    field_t*   fieldPosition;

    SqlGuiView* view;

		bool connectionEnabled;

};

#endif // SQLGUIDOC_H
